#include "system.h"
#include "stabilizer.h"
#include "sensors.h"
//#include "commander.h"
#include "anomal_detec.h"
#include "state_control.h"
#include "state_estimator.h"
#include "power_control.h"
#include "flip.h"

/*FreeRTOSͷļ*/
#include "FreeRTOS.h"
#include "task.h"

static u32 sysTickCnt=0;
static bool isInit;
static bool isCalibPass;
static setpoint_t 	setpoint;	/*Ŀ״̬*/
static sensorData_t sensorData;	/**/
static state_t 		state;		/*̬*/
static control_t 	control;	/*Ʋ*/

void stabilizerTask(void* param);

void stabilizerInit(void)
{
	if(isInit) return;

	sensorsInit();			/*ʼ*/

	isInit = true;
}

bool stabilizerTest(void)
{
	bool pass = true;

	pass &= sensorsTest();
	pass &= stateControlTest();//	stateControlInit();		/*̬PIDʼ*/
//	pass &= powerControlTest();

	return pass;
}

/********************************************************
*getSysTickCnt()
*ȿ֮ǰ  sysTickCnt
*ȿ֮ǰ  xTaskGetTickCount()
*********************************************************/
u32 getSysTickCnt(void)
{
	if(xTaskGetSchedulerState()!=taskSCHEDULER_NOT_STARTED)	/*ϵͳѾ*/
		return xTaskGetTickCount();
	else
		return sysTickCnt;
}


void stabilizerTask(void* param)
{
	u32 tick = 0;
	u32 lastWakeTime = getSysTickCnt();
	attitude_t attitude;
	while(!sensorsAreCalibrated())
	{
		vTaskDelayUntil(&lastWakeTime, MAIN_LOOP_DT);
	}
	isCalibPass = true;
	printf("sensorsAreCalibrated ok\r\n");
	while(1) 
	{
		vTaskDelayUntil(&lastWakeTime, MAIN_LOOP_DT);		/*1msʱ*/

		sensorsAcquire(&sensorData, tick);					/*ȡ6ѹ*/
		stateEstimator(&state, &sensorData, tick);			/*Ԫ ŷǼ*/
	
		if(tick%60==0)
		{
			getAttitudeData(&attitude);
			printf(" %.01f %.01f %.01f\r\n",attitude.roll, attitude.pitch, -attitude.yaw);
		}
		tick++;
	}
}

void getAttitudeData(attitude_t* get)
{
	*get = state.attitude;
}

float getBaroData(void)
{
	return sensorData.baro.asl;
}

bool getIsCalibPass(void)
{
	return isCalibPass;
}
