#include "iic1.h"
#include "delay.h"
#include "stdbool.h"	


static bool isInit;

static void iicDevStart(void);			//iicʼź
static void iicDevStop(void);	  		//iicֹͣź
static void iicDevAck(void);			//iicACKź
static void iicDevNAck(void);			//iicACKź 
static u8 iicDevWaitAck(void);			//iicȴACKź
static void iicDevSendByte(u8 txd);		//iicһֽ
static u8 iicDevReceiveByte(u8 ack);	//iicȡһֽ

//ʼiic
void iicDevInit(void)
{	
  if(isInit)	return;
   GPIO_InitTypeDef  GPIO_InitStructure;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);//ʹIO PORTCʱ 
		
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10|GPIO_Pin_11;	 // ˿
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IOٶΪ50MHz
  GPIO_Init(GPIOB, &GPIO_InitStructure);					 //趨ʼGPIO 
	
  GPIO_SetBits(GPIOB,GPIO_Pin_10|GPIO_Pin_11);						 //PB10,PB11 	

	IIC1_SCL=1;
	IIC1_SDA=1;
	
	isInit=true;
}
//IIC1ʼź
static void iicDevStart(void)
{
	SDA_OUT();     //sda
	IIC1_SDA=1;	  	  
	IIC1_SCL=1;
	delay_us(4);
 	IIC1_SDA=0;//START:when CLK is high,DATA change form high to low 
	delay_us(4);
	IIC1_SCL=0;//ǯסI2Cߣ׼ͻ 
}	  
//IIC1ֹͣź
static void iicDevStop(void)
{
	SDA_OUT();//sda
	IIC1_SCL=0;
	IIC1_SDA=0;//STOP:when CLK is high DATA change form low to high
 	delay_us(4);
	IIC1_SCL=1; 
	IIC1_SDA=1;//I2C߽ź
	delay_us(4);							   	
}
//ȴӦźŵ
//ֵ1Ӧʧ
//        0Ӧɹ
static u8 iicDevWaitAck(void)
{
	u8 ucErrTime=0;
	SDA_IN();      //SDAΪ  
	IIC1_SDA=1;delay_us(1);	   
	IIC1_SCL=1;delay_us(1);	 
	while(READ_SDA)
	{
		ucErrTime++;
		if(ucErrTime>250)
		{
			iicDevStop();
			return 1;
		}
	}
	IIC1_SCL=0;//ʱ0 	   
	return 0;  
} 
//ACKӦ
static void iicDevAck(void)
{
	IIC1_SCL=0;
	SDA_OUT();
	IIC1_SDA=0;
	delay_us(1);
	IIC1_SCL=1;
	delay_us(1);
	IIC1_SCL=0;
}
//ACKӦ		    
static void iicDevNAck(void)
{
	IIC1_SCL=0;
	SDA_OUT();
	IIC1_SDA=1;
	delay_us(1);
	IIC1_SCL=1;
	delay_us(1);
	IIC1_SCL=0;
}					 				     
//IIC1һֽ
//شӻӦ
//1Ӧ
//0Ӧ			  
static void iicDevSendByte(u8 txd)
{                        
    u8 t;   
	SDA_OUT(); 	    
    IIC1_SCL=0;//ʱӿʼݴ
    for(t=0;t<8;t++)
    {              
        IIC1_SDA=(txd&0x80)>>7;
        txd<<=1; 	  
		delay_us(1);   
		IIC1_SCL=1;
		delay_us(1); 
		IIC1_SCL=0;	
		delay_us(1);
    }	 
} 	    
//1ֽڣack=1ʱACKack=0nACK   
static u8 iicDevReceiveByte(u8 ack)
{
	u8 i,receive=0;
	SDA_IN();//SDAΪ
    for(i=0;i<8;i++ )
	{
        IIC1_SCL=0; 
        delay_us(1);
		IIC1_SCL=1;
        receive<<=1;
        if(READ_SDA)receive++;   
		delay_us(1); 
    }					 
    if (!ack)
        iicDevNAck();//nACK
    else
        iicDevAck(); //ACK   
    return receive;
}

//ַָһ
//ReadAddr:ʼĵַ  
//ֵ  :
u8 iicDevReadByte(u8 devaddr,u8 addr)
{				  
	u8 temp=0;		  	    																 
	iicDevStart();  
	iicDevSendByte(devaddr);//д 	   
	iicDevWaitAck(); 
	iicDevSendByte(addr);   //͵͵ַ
	iicDevWaitAck();	

	iicDevStart();  	 	   
	iicDevSendByte(devaddr|1);//			   
	iicDevWaitAck();	 
	temp=iicDevReceiveByte(0);			   
	iicDevStop();//һֹͣ	    
	return temp;
}
//ֽ
//addr:ʼַ
//rbuf:ݻ
//len:ݳ
void iicDevRead(u8 devaddr,u8 addr,u8 len,u8 *rbuf)
{
	int i=0;
	iicDevStart();  
	iicDevSendByte(devaddr);  
	iicDevWaitAck();	
	iicDevSendByte(addr);//ַ  
	iicDevWaitAck();	

	iicDevStart();  	
	iicDevSendByte(devaddr|1);  	
	iicDevWaitAck();	
	for(i=0; i<len; i++)
	{
		if(i==len-1)
		{
			rbuf[i] = iicDevReceiveByte(0);//һֽڲӦ
		}
		else
			rbuf[i] = iicDevReceiveByte(1);
	}
	iicDevStop( );	
}
//ַָдһ
//WriteAddr :дݵĿĵַ    
//DataToWrite:Ҫд
void iicDevWriteByte(u8 devaddr,u8 addr,u8 data)
{				   	  	    																 
	iicDevStart();  
	iicDevSendByte(devaddr); //д 	 
	iicDevWaitAck();	   
	iicDevSendByte(addr);   //͵͵ַ
	iicDevWaitAck(); 	 										  		   
	iicDevSendByte(data); //ֽ							   
	iicDevWaitAck();  		    	   
	iicDevStop();		//һֹͣ 	 
}

//дֽ
//addr:ʼַ
//wbuf:дݻ
//len:ݵĳ
void iicDevWrite(u8 devaddr,u8 addr,u8 len,u8 *wbuf)
{
	int i=0;
	iicDevStart();  
	iicDevSendByte(devaddr);  	
	iicDevWaitAck();	
	iicDevSendByte(addr);  //ַ
	iicDevWaitAck();	
	for(i=0; i<len; i++)
	{
		iicDevSendByte(wbuf[i]);  
		iicDevWaitAck();		
	}
	iicDevStop( );	
}

























