#include "debug_cmdshell.h"

const cmd_list_struct cmd_list[]={
//                   Ϣ
{"hello",0,(void* )printf_hello,   "hello                     -print HelloWorld!\r\n"},
{"arg",8,(void* )handle_arg,       "arg<arg1> <arg2> ...      -print args\r\n"},
{"help",0,(void* )printf_help,     "help                      -print help\r\n"},
};
cmd_analyze_struct cmd_analyze;


void printf_hello(int32_t argc,void *cmd_arg)
{
   printf("Hello world!\r\n");
}


void handle_arg(int32_t argc,void * cmd_arg)
{
   uint32_t i;
   int32_t  *arg=(int32_t *)cmd_arg;
    if(argc==0)
    {
       printf("no arg\n");
    }
    else
    {
       for(i=0;i<argc;i++)
       {
         printf("arg %d is : %d",i+1,arg[i]);  
       }
    }
}

void printf_help(int32_t argc,void * cmd_arg)
{
	int i;
	for(i=0;i<sizeof(cmd_list)/sizeof(cmd_list[0]);i++)
	{
		printf("%s",cmd_list[i].help);
	}
}

static uint32_t get_true_char_stream(char *dest,const char *src)

{
   uint32_t dest_count=0;
   uint32_t src_count=0;
    while(src[src_count]!='\0')
    {
       if(isprint(src[src_count]))
       {
           dest[dest_count++]=src[src_count++];
       }
       else
       {
           switch(src[src_count])
           {
                case    0x08:
                {
                    if(dest_count>0)
                    {
                        dest_count --;
                    }
                    src_count ++;
                }break;
                case    0x1B:
                {
                    if(src[src_count+1]==0x5B)
                    {
                        if(src[src_count+2]==0x41 || src[src_count+2]==0x42)
                        {
                            src_count +=3;
                        }
                        else if(src[src_count+2]==0x43)
                        {
                            dest_count++;
                            src_count+=3;
                        }
                        else if(src[src_count+2]==0x44)
                        {
                            if(dest_count >0)
                            {
                                dest_count --;
                            }
                           src_count +=3;
                        }
                        else
                        {
                            src_count +=3;
                        }
                    }
                    else
                    {
                        src_count ++;
                    }
                }break;
                default:
                {
                    src_count++;
                }break;
           }
       }
    }
   //dest[dest_count++]=src[src_count++];
    //dest[dest_count++]=src[src_count++];
    return dest_count;
}
static int32_t string_to_dec(uint8_t *buf,uint32_t len)

{
   uint32_t i=0;
   uint32_t base=10;
   int32_t  neg=1;
   int32_t  result=0;
    if((buf[0]=='0')&&(buf[1]=='x'))
    {
       base=16;
       neg=1;
       i=2;
    }
    else if(buf[0]=='-')
    {
       base=10;
       neg=-1;
       i=1;
    }
    for(;i<len;i++)
    {
       if(buf[i]==0x20 || buf[i]=='\0')
       {
           break;
       }
       result *= base;
       if(isdigit(buf[i]))
       {
           result += buf[i]-'0';
       }
       else if(isxdigit(buf[i]))
       {
            result+=tolower(buf[i])-87;
       }
       else
       {
           result += buf[i]-'0';
       }                                        
    }
   result *= neg;
    return result ;
}


static int32_t cmd_arg_analyze(char *rec_buf,unsigned int len)

{

   uint32_t i;
   uint32_t blank_space_flag=0;
   uint32_t arg_num=0; 
   uint32_t index[ARG_NUM]; 

    for(i=0;i<len;i++)
    {
       if(rec_buf[i]==0x20)
       {
           blank_space_flag=1;             
           continue;
       }
        else if(rec_buf[i]=='\0')  
       {
           break;
       }
       else
       {
           if(blank_space_flag==1)
           {
                blank_space_flag=0; 
                if(arg_num < ARG_NUM)
                {
                   index[arg_num]=i;
                    arg_num++;         
                }
                else
                {
                    return -1;
                }
           }
       }
    }
    for(i=0;i<arg_num;i++)
    {
			  //arg 1 2 0x10
        cmd_analyze.cmd_arg[i]=string_to_dec((unsigned char *)(rec_buf+index[i]),len-index[i]);
			  printf("i:%d, arg[%d]=%d\r\n",i,i,cmd_analyze.cmd_arg[i]);
    }
    return arg_num;
}

//
/*
* ڲ  data    :    Ҫַ   עַѾ \r\n ȥ
            datalen :    ַ
*/
void debugcmd_process(u8* data,u8 datalen)
{
		u8 i;
		int rec_num;
		int32_t rec_arg_num;
		char cmd_buf[CMD_LEN]; 
		if(datalen<CMD_BUF_LEN)
		{
			for(i=0;i<datalen;i++)
			{
				cmd_analyze.rec_buf[i]=data[i];
			}
			rec_num=get_true_char_stream(cmd_analyze.processed_buf,cmd_analyze.rec_buf);

			 for(i=0;i<CMD_LEN;i++)
			 {
					 if((i>0)&&((cmd_analyze.processed_buf[i]==' ')||(cmd_analyze.processed_buf[i]==0x0D)))
					 {
								cmd_buf[i]='\0';
								break;
					 }
					 else
					 {
								cmd_buf[i]=cmd_analyze.processed_buf[i];
					 }
			 }
			 //printf("[debug] %s\r\n",cmd_buf);
				rec_arg_num=cmd_arg_analyze(&cmd_analyze.processed_buf[i],rec_num);
				for(i=0;i<sizeof(cmd_list)/sizeof(cmd_list[0]);i++)
			 {
					 if(!strcmp(cmd_buf,cmd_list[i].cmd_name))
					 {
								if(rec_arg_num<0 || rec_arg_num>cmd_list[i].max_args)
								{
									 printf("args is too many\r\n");
								}
								else
								{
										cmd_list[i].handle(rec_arg_num,(void *)cmd_analyze.cmd_arg);
								}
								break;
					 }

			 }
			 if(i>=sizeof(cmd_list)/sizeof(cmd_list[0]))
			 {
					 printf("cmd is not support\r\n");
			 }

			memset(cmd_analyze.rec_buf,0,CMD_BUF_LEN);
			memset(cmd_analyze.processed_buf,0,CMD_BUF_LEN);
			memset(cmd_buf,0,CMD_LEN);
		}
}
